package com.ut.mini.base;

/**
 * 
 * @author daichenjie 独立了一个包名 com.ut.mini.base 方便做到和对外的隔离
 */
public class UTMCConstants {

	/**
	 * 传输SDK版本号
	 */
	public final static String G_SDK_VERSION = "4.1.0";
	
	/**
	 * 最大记录大小
	 */
	public final static int G_MAX_PER_LOG_SIZE = 100 * 1024;//100kb
	
	/**
	 * 最大上传单个包大小
	 */
	public final static int G_MAX_PER_UPLOAD_PACKAGE_SIZE = 100 * 1024;//100kb

	/**
	 * log缓存容量:1000条,尽量避免IO的问题
	 */
	public final static int G_LOG_CACHE_CAPACITY = 1000;

	public final static int G_MAX_CONNECTION_TIME_OUT = 10 * 1000;
	public final static int G_MAX_READ_CONNECTION_STREAM_TIME_OUT = 30 * 1000;
	
	public static class EventID{
		public final static int AGGREGATION_LOG = 6699;
	}
	
	public static String G_FIXED_TRANSFER_URL = "http://adash.m.taobao.com/rest/sur";
	// 传输日志的Url
	private static String G_TRANSFER_URL = "http://adash.m.taobao.com/rest/sur";
	// 获取配置的URL
	public final static String G_CONF_URL = "http://adash.m.taobao.com/rest/gc";
	// abtest
	public final static String G_ABTEST_URL = "http://adash.m.taobao.com/rest/abtest";

	public final static int G_MAX_PER_TRANSFER_COUNT = 100;
	
	public synchronized static String getTransferUrl(){
		return G_TRANSFER_URL;
	}
	
	public synchronized static void setTransferUrl(String aUrl){
		G_TRANSFER_URL = aUrl;
	}
	
	public final static class StorageKeys {
		/**
		 * 日志存储到SP的前缀
		 */
		public final static String G_LOG_STORAGE_SP_NAME_PREFIX = "UTMCLog";
		public final static String G_LOG_STORAGE_CONF_NAME_PREFIS = "UTMCConf";
	}

	/*
	 * 返回RC4的私钥
	 */
	public static String getRC4PrivateKey() {
		return "QrMgt8GGYI6T52ZY5AnhtxkLzb8egpFn3j5JELI8H6wtACbUnZ5cc3aYTsTRbmkAkRJeYbtx92LPBWm7nBO9UIl7y5i5MQNmUZNf5QENurR5tGyo7yJ2G0MBjWvy6iAtlAbacKP0SwOUeUWx5dsBdyhxa7Id1APtybSdDgicBDuNjI0mlZFUzZSS9dmN8lBD0WTVOMz0pRZbR3cysomRXOO1ghqjJdTcyDIxzpNAEszN8RMGjrzyU7Hjbmwi6YNK";
	}

	public static class LogContentKeys {
		public final static String PRIORITY = "_priority";
	}

	public final class PrivateLogFields {
		// 宿主appkey
		public final static String HOST_APPKEY = "_hak";
		public final static String HOST_APPVERSION = "_hav";
		public final static String SEND_LOG_SYNC = "_sls";
	}

	/**
	 * 日志传输的紧急程度
	 * 
	 * @author daichenjie 调低正常等级，默认级别以上的级别可控制的力度更多一些哈。
	 */
	public static class LogTransferLevel {
		public final static String URGENT = "9";
		public final static String HIGH = "8";
		public final static String L7 = "7";
		public final static String L6 = "6";
		public final static String L5 = "5";
		public final static String L4 = "4";
		public final static String NROMAL = "3";
		public final static String L2 = "2";
		public final static String L1 = "1";
		public final static String LOW = "0";
	}

	public static class OnlineConfBusiness {
		public final static String EVENT_STRAEM_GROUP = "B01N17";
		public final static String REAL_TIME_DEBUGGING = "B01N4";
	}

}
