package com.ut.mini.core;

import java.util.Map;

import android.os.Handler;
import android.os.HandlerThread;
import android.os.Message;

import com.ut.mini.base.UTMCConstants;

public class UTMCSendLogDelegate {

	private final static int SEND_LOG_HANDLER_MSG_ID = 1;
	private HandlerThread mHandlerThread = null;
	private Handler mHandler = null;
	private ISendLogListener mListener = null;

	public UTMCSendLogDelegate() {
	}
	
	public void start(){
		mHandlerThread = new HandlerThread("UT-INVOKE-ASYNC");
		mHandlerThread.start();
		mHandler = new Handler(mHandlerThread.getLooper()) {

			@Override
			public void handleMessage(Message msg) {
				if (msg.what == SEND_LOG_HANDLER_MSG_ID) {
					if (null != msg.obj) {
						Map<String, String> lLogMap = (Map<String, String>) msg.obj;
						if(null != mListener){
							mListener.onLogArrived(lLogMap);
						}
					}else{
						mListener.onLogArrived(null);
					}
				}
			}

		};
	}
	
	public void setSendLogListener(ISendLogListener aListener){
		mListener = aListener;
	}

	// 对Tracker发送过来的Map做一些简单的处理，调用UTMCLogTransferMain：进行Log传输
	// 我们会在helper中，把不合法的key去除掉。
	// 要加入异步的机制
	public void send(Map<String, String> aLogMap) {
		// 修正微博的bug
		if(null == mHandler){
			return;
		}
		if (null != aLogMap) {
			// 提交log给UTMCLogTransferMain，发送Log
			if (aLogMap
					.containsKey(UTMCConstants.PrivateLogFields.SEND_LOG_SYNC)) {

				aLogMap.remove(UTMCConstants.PrivateLogFields.SEND_LOG_SYNC);
				
				if(null != mListener){
					mListener.onLogArrived(aLogMap);
					return;
				}
	
			}
		}
			
		// 从池子里获取一个Message.
		Message lMessage = Message.obtain();
		lMessage.what = SEND_LOG_HANDLER_MSG_ID;
		lMessage.obj = aLogMap;
		mHandler.sendMessage(lMessage);
			
	}

	public interface ISendLogListener{
		void onLogArrived(Map<String, String> aLogMap);
	}
}
