package com.ut.mini.core.appstatus;

import java.util.HashMap;

import android.app.Activity;
import android.os.Bundle;
import android.os.SystemClock;

import com.ut.mini.core.UTMCVariables;
import com.ut.mini.core.onlineconf.UTMCTPKBiz;

public class UTMCAppBackgroundTimeoutDetector implements UTMCAppStatusCallbacks{
	
	private long mSwitchBackgroundTimestamp = 0;
	private final static long TIMEOUT = 30 * 1000;
	private static UTMCAppBackgroundTimeoutDetector s_instance = null;
	
	private UTMCAppBackgroundTimeoutDetector(){
		
	}
	
	public synchronized static UTMCAppBackgroundTimeoutDetector getInstance(){
		if(null == s_instance){
			s_instance = new UTMCAppBackgroundTimeoutDetector();
		}
		return s_instance;
	}
	
	@Override
	public void onSwitchBackground() {
		mSwitchBackgroundTimestamp = SystemClock.elapsedRealtime();
	}

	@Override
	public void onSwitchForeground() {
		if(0 != mSwitchBackgroundTimestamp){
			if(SystemClock.elapsedRealtime() - mSwitchBackgroundTimestamp > TIMEOUT){
				UTMCTPKBiz.getInstance().sessionTimeout();
				// 清空sessionProperties
				UTMCVariables.getInstance().setSessionProperties(new HashMap<String,String>());
			}
		}
		mSwitchBackgroundTimestamp = 0;
	}

	@Override
	public void onActivityCreated(Activity activity, Bundle savedInstanceState) {
		
	}

	@Override
	public void onActivityDestroyed(Activity activity) {
		
	}

	@Override
	public void onActivityPaused(Activity activity) {
		
	}

	@Override
	public void onActivityResumed(Activity activity) {
		
	}

	@Override
	public void onActivitySaveInstanceState(Activity activity, Bundle outState) {
		
	}

	@Override
	public void onActivityStarted(Activity activity) {
		
	}

	@Override
	public void onActivityStopped(Activity activity) {
		
	}
	
}
