package com.ut.mini.core.loghelper;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import android.content.Context;
import android.net.wifi.WifiInfo;
import android.net.wifi.WifiManager;

import com.ta.utdid2.android.utils.StringUtils;
import com.ut.mini.base.UTLogFieldsScheme;
import com.ut.mini.base.UTMCLogFields;
import com.ut.mini.base.UTMCStatConfig;
import com.ut.mini.core.UTMCDevice;
import com.ut.mini.core.UTMCVariables;
import com.ut.mini.utils.UTMCStringUtils;

public class UTMCLogAssemble {

	private static long s_default_session_timestamp = System
			.currentTimeMillis();
	private static String s_bssid = null;

	public static long getSessionTimestamp(){
		return s_default_session_timestamp;
	}
	
	private static String _checkField(String pField) {
		if (UTMCStringUtils.isEmpty(pField)) {
			return "-";
		}
		return pField;
	}

	/**
	 * 鎶奓og缁勮鎴愭棩蹇楋紙杩欓噷浼氭妸璁惧鍩虹淇℃伅涔熸嫾瑁呰繘鍘伙級
	 * 
	 * @param aLogMap
	 *            Log鍐呭
	 * @return 鏃ュ織瀛楃涓�
	 * 
	 *         bug fix锛氬幓闄や簡杩愯惀鍟嗭紝缃戠粶锛岀綉缁滃瓙绫诲瀷锛岃繕鏈夎瑷� 鐨勪繚鎶わ紝鍏佽澶栭儴瑕嗙洊锛屽鏋滀笉鍘婚櫎锛屽拰CEC鍔熻兘鍐茬獊
	 */
	public static String assemble(Map<String, String> aLogMap) {
		if (null != aLogMap && aLogMap.size() > 0) {

			String lHostPackageImei = UTMCVariables.getInstance()
					.getHostPackageImei();
			String lHostPackageImsi = UTMCVariables.getInstance()
					.getHostPackageImsi();
			if (null != lHostPackageImei && null != lHostPackageImsi) {
				if (null == aLogMap.get(UTLogFieldsScheme.IMEI.toString())
						&& null == aLogMap.get(UTLogFieldsScheme.IMSI
								.toString())) {
					aLogMap.put(UTLogFieldsScheme.IMEI.toString(),
							lHostPackageImei);
					aLogMap.put(UTLogFieldsScheme.IMSI.toString(),
							lHostPackageImsi);
				}
			}

			// 璧沴ong usernick杩涘幓
			if (!UTMCStringUtils.isEmpty(UTMCStatConfig.getInstance()
					.getUsernick())) {
				aLogMap.put(UTLogFieldsScheme.USERNICK.toString(),
						UTMCStatConfig.getInstance().getUsernick());
			}

			if (!UTMCStringUtils.isEmpty(UTMCStatConfig.getInstance()
					.getLongLoginUsernick())) {
				aLogMap.put(UTLogFieldsScheme.LL_USERNICK.toString(),
						UTMCStatConfig.getInstance().getLongLoginUsernick());
			}
			if (!UTMCStringUtils.isEmpty(UTMCStatConfig.getInstance()
					.getUserid())) {
				aLogMap.put(UTLogFieldsScheme.USERID.toString(), UTMCStatConfig
						.getInstance().getUserid());
			}

			if (!UTMCStringUtils.isEmpty(UTMCStatConfig.getInstance()
					.getLongLoingUserid())) {
				aLogMap.put(UTLogFieldsScheme.LL_USERID.toString(),
						UTMCStatConfig.getInstance().getLongLoingUserid());
			}

			if (!aLogMap.containsKey(UTLogFieldsScheme.SDKVERSION.toString())) {
				aLogMap.put(UTLogFieldsScheme.SDKVERSION.toString(),
						UTMCStatConfig.getInstance().getBuildInfo()
								.getFullSDKVersion());
			}

			if (!aLogMap.containsKey(UTLogFieldsScheme.APPKEY.toString())) {
				aLogMap.put(UTLogFieldsScheme.APPKEY.toString(), UTMCStatConfig
						.getInstance().getAppkey());
			}

			if (!UTMCStringUtils.isEmpty(UTMCStatConfig.getInstance()
					.getChannel())) {
				aLogMap.put(UTLogFieldsScheme.CHANNEL.toString(),
						UTMCStatConfig.getInstance().getChannel());
			}

			if (!UTMCStringUtils.isEmpty(UTMCStatConfig.getInstance()
					.getAppVersion())) {
				aLogMap.put(UTLogFieldsScheme.APPVERSION.toString(),
						UTMCStatConfig.getInstance().getAppVersion());
			}

			// 濡傛灉鏃ュ織娌℃湁鎸囧畾鏃堕棿锛岄偅涔堟垜浠敓鎴愪竴涓斁杩涘幓
			if (!aLogMap.containsKey(UTLogFieldsScheme.RECORD_TIMESTAMP
					.toString())) {
				aLogMap.put(UTLogFieldsScheme.RECORD_TIMESTAMP.toString(), ""
						+ System.currentTimeMillis());
			}

			// 濡傛灉娌℃湁鎸囧畾浼氳瘽鏃堕棿锛岄偅涔堟垜浠粯璁ゅ～鍐欎竴涓浐瀹氱殑timestamp
			if (!aLogMap
					.containsKey(UTLogFieldsScheme.START_SESSION_TIMESTAMP
							.toString())) {
				aLogMap.put(
						UTLogFieldsScheme.START_SESSION_TIMESTAMP.toString(),
						"" + s_default_session_timestamp);
			}

			Map<String, String> lDeviceInfoMap = UTMCDevice
					.getDeviceInfo(UTMCStatConfig.getInstance().getContext());
			if (null != lDeviceInfoMap) {

				Map<String, String> lLogMapNew = new HashMap<String, String>();
				// 鎶婅澶囦俊鎭痯ut鍒伴噷闈㈠幓
				lLogMapNew.putAll(lDeviceInfoMap);
				// 鍐嶆妸鏃ュ織鍐呭鍐峱ut杩涘幓锛岃繖閲屼互澶栭儴鐨勫�间负鍑嗭紝涔熷氨鏄imei锛宨msi绛夛紝澶栭儴鍙鐩栧唴瀹�
				// 濡傛灉鏄繖浜涘瓧娈碉紝閭ｄ箞涓嶈兘琚鐩�
				Iterator<String> lOKeys = aLogMap.keySet().iterator();
				while (lOKeys.hasNext()) {
					String lKey = lOKeys.next();
					if (lKey.equals(UTLogFieldsScheme.BRAND.toString())
							|| lKey.equals(UTLogFieldsScheme.DEVICE_MODEL
									.toString())
							|| lKey.equals(UTLogFieldsScheme.RESOLUTION
									.toString())
							|| lKey.equals(UTLogFieldsScheme.OS.toString())
							|| lKey.equals(UTLogFieldsScheme.OSVERSION
									.toString())
							|| lKey.equals(UTLogFieldsScheme.UTDID.toString())
							|| lKey.equals(UTMCLogFields.ALIYUN_PLATFORM_FLAG
									.toString())) {
						continue;
					}
					String lValue = aLogMap.get(lKey);
					// Fix:淇敼value涓嶈兘涓�0闀垮害鐨勫瓧绗︼紝鍙樻垚涓嶈兘涓簄ull
					if (!UTMCStringUtils.isEmpty(lKey) && null != lValue) {
						lLogMapNew.put(lKey, lValue);
					}
				}
				
				// 濡傛灉鍖呭惈闃块噷浜戠郴缁熻繖涓爣蹇楋紝閭ｄ箞鎴戜滑鏇挎崲瀹�
				if(aLogMap.containsKey(UTMCLogFields.ALIYUN_PLATFORM_FLAG.toString())){
					// 杩欎釜"y"搴旇缁熶竴鍦ㄤ竴涓枃浠朵腑鏄渶濂界殑锛岀幇鍦ㄥ啀缁х画杩欎箞涓存椂鍐欑殑銆傛�曟敼鍔ㄥお澶с��
					lLogMapNew.put(UTLogFieldsScheme.OS.toString(), "y");
				}

				// 濉厖Reserves瀛楁:涓嬮潰鐨勪唬鐮佸凡缁忓嚭鐜伴噸澶嶄簡锛岃繖涓啀鎺ヤ笅鏉ラ渶瑕佽�冭檻鎬庝箞鍘诲仛浼樺寲浜嗗Map鍗忚鏉ュ仛銆�
				String lReserves = (String) lLogMapNew
						.get(UTLogFieldsScheme.RESERVES.toString());
				String lMacStr = (String) lLogMapNew.get("_mac");
				if (lMacStr != null) {
					if (lReserves != null) {
						lReserves += ",_mac=" + lMacStr;
					} else {
						lReserves = "_mac=" + lMacStr;
					}
					lLogMapNew.remove("_mac");
				}
				
				String ABIInfo = UTMCABIHelper.getABI();
				if (!StringUtils.isEmpty(ABIInfo)) {
					if (lReserves != null) {
                        lReserves += ",_abi=" + ABIInfo;
					} else {
                        lReserves = "_abi=" + ABIInfo;
					}
				}

				String lDeviceId = (String) lLogMapNew
						.get(UTMCLogFields.DEVICE_ID.toString());
				if (lDeviceId != null) {
					if (lReserves != null) {
						lReserves += ",_did=" + lDeviceId;
					} else {
						lReserves = "_did=" + lDeviceId;
					}
					lLogMapNew.remove(UTMCLogFields.DEVICE_ID.toString());
				}
				
				// 鍏煎umid鍒皉eserves瀛楁涓幓
				String lUMID = UTMCLogAssembleHelper
						.getSecurityToken(UTMCStatConfig.getInstance()
								.getContext());
				if (lUMID != null) {
					if (lLogMapNew.containsKey(UTLogFieldsScheme.UTDID
							.toString())) {
						if (lUMID.equals(lLogMapNew.get(UTLogFieldsScheme.UTDID
								.toString()))) {
							lUMID = "utdid";
						}
					}
					if (lReserves != null) {
						lReserves += ",_umid=" + lUMID;
					} else {
						lReserves = "_umid=" + lUMID;
					}
				}
				
				if(s_bssid == null){
					String lBSSID = _getBSSID(UTMCStatConfig.getInstance().getContext());
					if(null == lBSSID){
						s_bssid = "";
					}else{
						s_bssid = lBSSID;
					}
				}
				
				if(!UTMCStringUtils.isEmpty(s_bssid)){
					if (lReserves != null) {
						lReserves = String.format("%s,_bssid=%s", lReserves, s_bssid);
					} else {
						lReserves = String.format("_bssid=%s", s_bssid);
					}
				}

				if (UTMCStatConfig.getInstance().isOldDevice()) {
					if (lReserves != null) {
						lReserves = String.format("%s,_io=%s", lReserves, "1");
					} else {
						lReserves = String.format("_io=%s", "1");
					}
				}

				Map<String, String> lSessionProperties = UTMCVariables
						.getInstance().getSessionProperties();
				if (null != lSessionProperties && lSessionProperties.size() > 0) {
					String lSessionPropertiesStr = UTMCStringUtils
							.convertMapToStringWithUrlEncoder(lSessionProperties);
					if (!UTMCStringUtils.isEmpty(lSessionPropertiesStr)) {
						if (lReserves != null) {
							lReserves = String.format("%s,%s", lReserves,
									lSessionPropertiesStr);
						} else {
							lReserves = lSessionPropertiesStr;
						}
					}
				}

				if (lReserves != null) {
					lLogMapNew.put(UTLogFieldsScheme.RESERVES.toString(),
							lReserves);
				}

				return assembleWithFullFields(lLogMapNew);
			}
		}
		return null;
	}

	/**
	 * 鍏ㄥ瓧娈电殑鏁版嵁鎷兼帴
	 * @param aLogMap
	 * @return
	 */
	public static String assembleWithFullFields(Map<String, String> aLogMap) {
		Map<String, String> lLogMapNew = aLogMap;
		StringBuffer lSb = new StringBuffer();
		for (UTLogFieldsScheme lEnumKey : UTLogFieldsScheme
				.values()) {
			// 濡傛灉鏄痑rgs瀛楁锛岄偅涔堟垜浠烦鍑篺or 寰幆
			if (lEnumKey == UTLogFieldsScheme.ARGS) {
				break;
			}

			String lV = null;
			if (lLogMapNew.containsKey(lEnumKey.toString())) {
				lV = UTMCStringUtils.convertObjectToString(lLogMapNew
						.get(lEnumKey.toString()));
				lLogMapNew.remove(lEnumKey.toString());
			}
			lSb.append(_checkField(lV)).append("||");
		}
		// 闄や笂杩板唴瀹逛箣澶栵紝閫氶�氶兘鍒椾负args鐨勮寖鐣�
		boolean lIsFirstArgFlag = true;

		// 鍗曠嫭澶勭悊args瀛楁锛岄伩鍏嶅拰鑰丼DK涓嶅吋瀹圭殑闂
		if (lLogMapNew.containsKey(UTLogFieldsScheme.ARGS.toString())) {
			String lArgs = UTMCStringUtils.convertObjectToString(lLogMapNew
					.get(UTLogFieldsScheme.ARGS.toString()));
			lSb.append(_checkField(lArgs));
			lLogMapNew.remove(UTLogFieldsScheme.ARGS.toString());
			lIsFirstArgFlag = false;
		}

		Iterator<String> lItorKeys = lLogMapNew.keySet().iterator();
		while (lItorKeys.hasNext()) {
			String lKey = lItorKeys.next();
			String lV = null;
			if (lLogMapNew.containsKey(lKey)) {
				lV = UTMCStringUtils
						.convertObjectToString(lLogMapNew.get(lKey));
			}
			// Fix:瀵逛簬args鐨剉alue鏍￠獙锛屾垜浠厑璁哥┖鍊硷紝涓嶈繑鍥�"-"
			if (lIsFirstArgFlag) {
				// 濡傛灉鏄痗rashhandler閲囬泦鐨勬暟鎹紝閭ｄ箞鎴戜滑闇�瑕佸吋瀹筍tackTrace鐨勫鐞嗛�昏緫
				if ("StackTrace".equals(lKey)) {
					lSb.append("StackTrace=====>").append(lV);
				} else {
					lSb.append(_checkField(lKey)).append("=").append(lV);
				}
				lIsFirstArgFlag = false;

			} else {
				// 濡傛灉鏄痗rashhandler閲囬泦鐨勬暟鎹紝閭ｄ箞鎴戜滑闇�瑕佸吋瀹筍tackTrace鐨勫鐞嗛�昏緫
				if ("StackTrace".equals(lKey)) {
					lSb.append(",").append("StackTrace=====>").append(lV);
				} else {
					lSb.append(",").append(_checkField(lKey)).append("=")
							.append(lV);
				}

			}
		}

		// 濡傛灉Log鏈�鍚庝竴涓唴瀹逛负||锛岄偅涔堟垜浠�
		String lLogResult = lSb.toString();
		if (!UTMCStringUtils.isEmpty(lLogResult)) {
			if (lLogResult.endsWith("||")) {
				lLogResult = lLogResult + "-";
			}
		}
		return lLogResult;
	}

	/**
	 * 鎷嗚ВLog
	 * 
	 * @param pLogContent
	 *            log鍐呭
	 * @return
	 */
	public static Map<String, String> disassemble(String pLogContent) {
		if (!UTMCStringUtils.isEmpty(pLogContent)) {
			Map<String, String> lDResult = new HashMap<String, String>();
			String[] lSplitResult = pLogContent.split("\\|\\|");
			if (null != lSplitResult && lSplitResult.length > 0) {
				int lLIndex = 0;
				for (UTLogFieldsScheme lEnumKey : UTLogFieldsScheme.values()) {
					if (lLIndex < lSplitResult.length
							&& null != lSplitResult[lLIndex]) {
						lDResult.put(lEnumKey.toString(), lSplitResult[lLIndex]);
					}
					lLIndex += 1;
				}
			}
			return lDResult;
		}
		return null;
	}

	private static String _getBSSID(Context aContext) {
		try{
			WifiManager wifi = (WifiManager) aContext.getSystemService(Context.WIFI_SERVICE);
			WifiInfo info = wifi.getConnectionInfo();
			return info.getBSSID();
		}catch(Throwable e){
			return null;
		}
	}

	/**
	 * 柏雍的UTLog类中使用到了这个方法，直接移过来的
	 */
	public static int getEventId(Map<String, String> lLogMap) {
		int eventId = 0;
		try {
			eventId = Integer.parseInt(lLogMap.get(UTLogFieldsScheme.EVENTID
					.toString()));
		} catch (Exception e) {
			e.printStackTrace();
		}
		return eventId;
	}
}
