package com.ut.mini.core.sign;

/**
 * 请求签名验证基类
 * @author daichenjie
 * 这个接口的实现类，完成了SDK与我们采集服务器签名校验的工作，也就是说，没有正确使用，会导致数据不能被我们的采集服务器接受.</p>
 * 这个类包含2个子类，{@link UTBaseRequestAuthentication}以及{@link UTSecuritySDKRequestAuthentication}.</p>
 * UTBaseRequestAuthentication:这个属于基本的签名，采用appkey+secret的方式校验，具体申请，请到http://open.taobao.com.</p>
 * UTSecuritySDKRequestAuthentication:这个属于使用阿里巴巴集团提供的无线保镖安全校验服务，对于secret，该sdk做了加密保护处理，具体，也请到
 * http://open.taobao.com申请使用.</p>
 * 
 */
public interface IUTRequestAuthentication {
	
	/**
	 * 返回appkey
	 * @return
	 */
	String getAppkey();
	/**
	 * 返回签名
	 * @return	签名结果
	 */
	String getSign(String toBeSignedStr);
}
