package com.ut.mini.internal.utprivate;

import java.util.Map;

import android.os.Build;

import com.ut.mini.base.UTMIVariables;
import com.ut.mini.core.UTMCVariables;
import com.ut.mini.core.appstatus.UTMCAppStatusRegHelper;
import com.ut.mini.core.request.UTMCUrlWrapper;
import com.ut.mini.internal.UTPlugin;
import com.ut.mini.log.UTMCLogger;
import com.ut.mini.plugin.UTPluginMgr;
import com.ut.mini.sdkevents.UTMI1010_2001Event;

public class UTFunctionAdjuster {
	
	private static UTFunctionAdjuster sInstance = null;
	
	private UTFunctionAdjuster(){
		
	}
	
	public static synchronized UTFunctionAdjuster getInstance(){
		if(null == sInstance){
			sInstance = new UTFunctionAdjuster();
		}
		return sInstance;
	}

	public void setLogPrefix(String aPrefixString){
		UTMCLogger.setLogPrefix(aPrefixString);
	}
	
	public void turnOnDevLogMode(){
		UTMCLogger.setDev(true);
	}
	
	public void turnOnDebugLogMode(){
		UTMCLogger.setDebug(true);
	}
	
	/**
	 * 注册插件
	 * @param aPlugin
	 */
	public void registerPlugin(UTPlugin aPlugin,boolean aAsyncMode){
		UTPluginMgr.getInstance().registerPlugin(aPlugin, aAsyncMode);
	}
	
	/**
	 * 反注册Plugin
	 * @param aPlugin
	 */
	public void unregisterPlugin(UTPlugin aPlugin) {
		UTPluginMgr.getInstance().unregisterPlugin(aPlugin);
	}
	
	/**
	 * 这个因为无痕依赖了一个URL的配置模块，所以这个 
	 */
	public String getSignedConfigurationUrl(String pUrl,Map<String, Object> pQueryMap,Map<String, Object> pDataMap) throws Exception{
		return UTMCUrlWrapper.getSignedConfigurationUrl(pUrl, pQueryMap, pDataMap);
	}
	
	/**
	 * 关闭MINISDK的2001及1010自动捕获的事情
	 */
	public void turnOf2001and1010(){
		if (Build.VERSION.SDK_INT < Build.VERSION_CODES.ICE_CREAM_SANDWICH) {
			UTPluginMgr.getInstance().unregisterPlugin(UTMIVariables.getInstance().getUTMI1010_2001EventInstance());
		} else {
			UTMCAppStatusRegHelper.unRegisterAppStatusCallbacks(UTMIVariables.getInstance().getUTMI1010_2001EventInstance());
		}
	}
	
}
