package com.ut.mini.module;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.net.ConnectivityManager;

import com.ut.mini.core.UTMCDevice;

public class UTNetWorkStatusChecker {

	public static void enable(Context context) {
		if (context == null) {
			return;
		}
		IntentFilter intentFilter = new IntentFilter(
				ConnectivityManager.CONNECTIVITY_ACTION);
		context.registerReceiver(netStatusReceiver, intentFilter);
	}

	public static void disable(Context context) {
		if (context == null) {
			return;
		}
		if (netStatusReceiver == null) {
			return;
		}
		context.unregisterReceiver(netStatusReceiver);
	}

	private static NetworkStatusReceiver netStatusReceiver = new NetworkStatusReceiver();
	private static NetWorkStatusCheckerRunnable netStatusCheckerRunnable = new NetWorkStatusCheckerRunnable();

	private static class NetworkStatusReceiver extends BroadcastReceiver {

		@Override
		public void onReceive(Context context, Intent intent) {
			netStatusCheckerRunnable.setContext(context);
			UTMCScheduleMgr.getInstance().submit(netStatusCheckerRunnable);
		}
	}

	private static class NetWorkStatusCheckerRunnable implements Runnable {

		private Context context;

		public NetWorkStatusCheckerRunnable setContext(Context context) {
			this.context = context;
			return this;
		}

		@Override
		public void run() {
			if (context == null) {
				return;
			}
			UTMCDevice.updateNetworkStatus(context);
		}

	}
}
