package com.ut.mini.plugin;

public abstract class UTPlugin {
	
	public final static int MSG_ID_IN_SWITCH_BACKGROUND = UTMsgIds.IN_SWITCH_BACKGROUND;
	public final static int MSG_ID_IN_SWITCH_FOREGROUND = UTMsgIds.IN_SWITCH_FOREGROUND;
	public final static int MSG_ID_IN_DISPATCH_AGGREGATION_LOG_MAP = UTMsgIds.IN_DISPATCH_AGGREGATION_LOG_MAP;
	public final static int MSG_ID_IN_NOMATCH_ONLINE_CONF = UTMsgIds.IN_NOMATCH_ONLINE_CONF;
//	public final static int MSG_ID_IN_DISPATCH_LOG_STRING = UTMsgIds.IN_DISPATCH_LOG_STRING;// UTAli 不需要用这个了
	public final static int MSG_ID_IN_DISPATCH_LOG_STRING_4_UTPERF_PLUGIN = UTMsgIds.IN_DISPATCH_LOG_STRING_4_UTPERF_PLUGIN;

	public final static int MSG_ID_OUT_AGGREGATED_LOG_MAP = UTMsgIds.OUT_AGGREGATED_LOG_MAP;
	
	private UTPluginContext mPluginContext = null;
	
	void setPluginContext(UTPluginContext aPluginContext){
		mPluginContext = aPluginContext;
	}
	
	public final UTPluginContext getPluginContext(){
		return mPluginContext;
	}
	
	public void onRegistered(){
		
	}
	
	/**
	 * 目前SDK不会主动调用这个方法，需要业务方自己主动调用这个生命周期，复写这个方法才会有回调
	 */
	public void onUnRegistered(){
		
	}
	
	public abstract int[] returnRequiredMsgIds();
	
	public String[] returnRequiredOnlineConfNames(){
		return null;
	}
 
	public abstract void onPluginMsgArrivedFromSDK(int aInPluginMsgId,Object aMsgObject);
	
	public final void deliverMsgToSDK(int aOutPluginMsgId,Object aMsgObject){
		UTPluginMgr.getInstance().dispatchPluginMsg(aOutPluginMsgId, aMsgObject);
	}
	
	public void onPluginContextValueUpdate(int aPluginContextKey){
		
	}
	
}
