package com.ut.mini.utils;

import java.lang.reflect.Method;

import android.util.Log;

public class SystemProperties {
	private static final String TAG = SystemProperties.class.getSimpleName();

	public static String get(String key) {
		String value = "";
		Class<?> cls = null;

		try {
			cls = Class.forName("android.os.SystemProperties");
			Method hideMethod = cls.getMethod("get", String.class);
			Object object = cls.newInstance();
			value = (String) hideMethod.invoke(object, key);
		} catch (Exception e) {
			Log.e(TAG, "get() ERROR!!! Exception!", e);
		}
		return value;
	}

	public static String get(String key, String defaultValue) {
		String value = "";
		Class<?> cls = null;

		try {
			cls = Class.forName("android.os.SystemProperties");
			Method hideMethod = cls.getMethod("get", String.class, String.class);
			Object object = cls.newInstance();
			value = (String) hideMethod.invoke(object, key, defaultValue);
		} catch (Exception e) {
			Log.e(TAG, "get() ERROR!!! Exception!", e);
		}
		return value;
	}
}
