package com.ut.mini.utils;

import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Properties;
import java.util.Set;

public class UTMCMapUtils {

	public static Map<String, String> convertObjectMapToStringMap(
			Map<String, Object> aMap) {
		if (null != aMap) {
			Map<String, String> lNewMap = new HashMap<String, String>();
			if (null != aMap && aMap.size() > 0) {
				Iterator<String> lKeys = aMap.keySet().iterator();
				if (null != lKeys) {
					while (lKeys.hasNext()) {
						String lKey = lKeys.next();
						String lValue = UTMCStringUtils
								.convertObjectToString(aMap.get(lKey));
						if (null != lKey) {
							lNewMap.put(lKey, lValue);
						}
					}
					return lNewMap;
				}
			}
		}
		return null;
	}
	
	public static Map<String,String> convertToUrlEncodedMap(Map<String,String> aMap) {
        if (null != aMap) {
        	Map<String,String> aNewMap = new HashMap<String,String>();
            Set<String> lKeys = aMap.keySet();
            for (String key : lKeys) {
                if (key instanceof String) {
                    String lValue = aMap.get(key);
                    if (!UTMCStringUtils.isEmpty(key)
                            && !UTMCStringUtils.isEmpty(lValue)) {
                        try {
                        	aNewMap.put(URLEncoder.encode(key, "UTF-8"),
                                    URLEncoder.encode(lValue, "UTF-8"));
                        } catch (UnsupportedEncodingException e) {
                            e.printStackTrace();
                        }
                    }
                }
            }
            return aNewMap;
        }
        return aMap;
    }
	
	public static Map<String,String> convertPropertiesToMap(Properties aProperties) {
        if (null != aProperties) {
        	Map<String,String> aNewMap = new HashMap<String,String>();
            Set<Object> lKeys = aProperties.keySet();
            for (Object key : lKeys) {
                if (key instanceof String) {
                	String lKeyStr = UTMCStringUtils.convertObjectToString(key);
                    String lValue = UTMCStringUtils.convertObjectToString(aProperties.get(key));
                    if (!UTMCStringUtils.isEmpty(lKeyStr)
                            && !UTMCStringUtils.isEmpty(lValue)) {
                        	aNewMap.put(lKeyStr,lValue);
                    }
                }
            }
            return aNewMap;
        }
        return null;
    }
	
	public static Map<String,String> convertStringAToMap(String ... aKVS){
		if(null != aKVS && aKVS.length > 0){
			for(int i=0;i<aKVS.length;i++){
				String lStrA = aKVS[i];
				if(aKVS.length > i){
					String lStrB = aKVS[i+1];
				}
			}
		}
		return null;
	}
	
}
