
package com.ut.mini.utils;

import android.app.Activity;
import android.content.Context;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;
import android.telephony.TelephonyManager;

import java.io.UnsupportedEncodingException;
import java.util.Random;

public class UTMCPhoneInfoUtils {

    private final static String STORAGE_KEY = "UTCommon";
    private final static Random s_random = new Random();

    public final static String getUniqueID() {
        int t1 = (int) (System.currentTimeMillis() / 1000);
        int t2 = (int) System.nanoTime();
        int t3 = s_random.nextInt();
        int t4 = s_random.nextInt();
        byte[] b1 = UTMCIntUtils.getBytes(t1);
        byte[] b2 = UTMCIntUtils.getBytes(t2);
        byte[] b3 = UTMCIntUtils.getBytes(t3);
        byte[] b4 = UTMCIntUtils.getBytes(t4);
        byte[] bUniqueID = new byte[16];
        System.arraycopy(b1, 0, bUniqueID, 0, 4);
        System.arraycopy(b2, 0, bUniqueID, 4, 4);
        System.arraycopy(b3, 0, bUniqueID, 8, 4);
        System.arraycopy(b4, 0, bUniqueID, 12, 4);
        return UTMCBase64.encodeToString(bUniqueID, UTMCBase64.NO_WRAP);
    }

    public static String getImei(Context context) {
        String imei = null;
        if (context != null) {
            try {
                SharedPreferences lSP = context.getSharedPreferences("UTCommon",
                        Context.MODE_PRIVATE);
                String lIE = lSP.getString("_ie", "");
                if (!UTMCStringUtils.isEmpty(lIE)) {
                    String lIMEI = new String(
                            UTMCBase64.decode(lIE.getBytes(), UTMCBase64.NO_WRAP), "UTF-8");
                    if (!UTMCStringUtils.isEmpty(lIMEI)) {
                        return lIMEI;
                    }
                }
            } catch (Exception e) {

            }
            try {
                TelephonyManager tm = (TelephonyManager) context
                        .getSystemService(Activity.TELEPHONY_SERVICE);
                if (tm != null) {
                    imei = tm.getDeviceId();
                }
            } catch (Exception e) {

            }
        }
        if (UTMCStringUtils.isEmpty(imei)) {
            imei = getUniqueID();
        }
        if (null != context) {
            try {
                SharedPreferences lSP = context.getSharedPreferences("UTCommon",
                        Context.MODE_PRIVATE);
                Editor lE = lSP.edit();
                lE.putString("_ie",
                        new String(UTMCBase64.encode(imei.getBytes("UTF-8"), UTMCBase64.NO_WRAP)));
                lE.commit();
            } catch (UnsupportedEncodingException e) {
                e.printStackTrace();
            }
        }
        return imei;
    }

    public static String getImsi(Context context) {
        String imsi = null;
        if (context != null) {
            try {
                SharedPreferences lSP = context.getSharedPreferences("UTCommon",
                        Context.MODE_PRIVATE);
                String lIS = lSP.getString("_is", "");
                if (!UTMCStringUtils.isEmpty(lIS)) {
                    String lIMSI = new String(
                            UTMCBase64.decode(lIS.getBytes(), UTMCBase64.NO_WRAP), "UTF-8");
                    if (!UTMCStringUtils.isEmpty(lIMSI)) {
                        return lIMSI;
                    }
                }
            } catch (Exception e) {

            }
            try {
                TelephonyManager tm = (TelephonyManager) context
                        .getSystemService(Activity.TELEPHONY_SERVICE);
                if (tm != null) {
                    imsi = tm.getSubscriberId();
                }
            } catch (Exception e) {

            }
        }
        if (UTMCStringUtils.isEmpty(imsi)) {
            imsi = getUniqueID();
        }
        if (null != context) {
            try {
                SharedPreferences lSP = context.getSharedPreferences("UTCommon",
                        Context.MODE_PRIVATE);
                Editor lE = lSP.edit();
                lE.putString("_is",
                        new String(UTMCBase64.encode(imsi.getBytes("UTF-8"), UTMCBase64.NO_WRAP)));
                lE.commit();
            } catch (UnsupportedEncodingException e) {
                e.printStackTrace();
            }
        }
        return imsi;
    }
}
