package com.ut.mini.utils;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

public final class UTMCReflectUtils {

	public static Object invokeSuperClassMethod(Object object,
			String methodName, Object[] args, Class... classes) {
		Method m;
		try {
			m = object.getClass().getSuperclass()
					.getDeclaredMethod(methodName, classes);
			m.setAccessible(true);
			return m.invoke(object, args);
		} catch (SecurityException e) {
			e.printStackTrace();
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			e.printStackTrace();
		}
		return null;
	}

	public static Object invokeSuperClassMethod(Object object, String methodName) {
		Method m;
		try {
			m = object.getClass().getSuperclass().getDeclaredMethod(methodName);
			m.setAccessible(true);
			return m.invoke(object);
		} catch (SecurityException e) {
			e.printStackTrace();
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			e.printStackTrace();
		}
		return null;
	}

	public static Object invokeStaticMethod(Class c, String methodName) {
		Method m;
		try {
			m = c.getDeclaredMethod(methodName);
			m.setAccessible(true);
			return m.invoke(null);
		} catch (SecurityException e) {
			e.printStackTrace();
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			e.printStackTrace();
		}
		return null;
	}

	public static Object invokeStaticMethod(Class c, String methodName,
			Object[] args, Class... classes) {
		Method m;
		try {
			m = c.getDeclaredMethod(methodName, classes);
			m.setAccessible(true);
			return m.invoke(null, args);
		} catch (SecurityException e) {
			e.printStackTrace();
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			e.printStackTrace();
		}
		return null;
	}

	public static Object invokeMethod(Object object, String methodName,
			Object[] args, Class... classes) {
		Method m;
		try {
			m = object.getClass().getDeclaredMethod(methodName, classes);
			m.setAccessible(true);
			return m.invoke(object, args);
		} catch (SecurityException e) {
			e.printStackTrace();
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			e.printStackTrace();
		}
		return null;
	}

	public static Object invokeMethod(Object object, String methodName) {
		Method m;
		try {
			m = object.getClass().getDeclaredMethod(methodName);
			m.setAccessible(true);
			return m.invoke(object);
		} catch (SecurityException e) {
			e.printStackTrace();
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			e.printStackTrace();
		}
		return null;
	}

	public static Object invokeStaticMethod(String className, String methodName) {
		Class c = null;
		try {
			c = Class.forName(className);
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
			return null;
		}
		if (c != null) {
			return invokeStaticMethod(c, methodName);
		}
		return null;
	}

	public static Object invokeStaticMethod(String className,
			String methodName, Object[] args, Class... classes) {
		Class c = null;
		try {
			c = Class.forName(className);
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
			return null;
		}
		if (c != null) {
			return invokeStaticMethod(c, methodName, args, classes);
		}
		return null;
	}

}
