package com.ut.mini.utils;

import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.util.Map;

public class UTMCStringUtils {

	public static boolean isEmpty(String str) {
		if (str != null && str.length() > 0) {
			return false;
		}
		return true;
	}

	public static String convertObjectToString(Object o) {
		if (o != null) {
			if (o instanceof String) {
				return ((String) o).toString();
			} else if (o instanceof Integer) {
				return "" + ((Integer) o).intValue();
			} else if (o instanceof Long) {
				return "" + ((Long) o).longValue();
			} else if (o instanceof Double) {
				return "" + ((Double) o).doubleValue();
			} else if (o instanceof Float) {
				return "" + ((Float) o).floatValue();
			} else if (o instanceof Short) {
				return "" + ((Short) o).shortValue();
			} else if (o instanceof Byte) {
				return "" + ((Byte) o).byteValue();
			} else if (o instanceof Boolean) {
				return ((Boolean) o).toString();
			} else if (o instanceof Character) {
				return ((Character) o).toString();
			} else {
				return o.toString();
			}
		}
		return "";
	}

	public static int hashCode(String value) {
		int h = 0;
		if (h == 0 && value.length() > 0) {
			char val[] = value.toCharArray();
			for (int i = 0; i < val.length; i++) {
				h = 31 * h + val[i];
			}
		}
		return h;
	}

	public static String convertMapToString(Map<String, String> pMaps) {
		if (null != pMaps) {
			boolean lIsFirst = true;
			StringBuffer lSB = new StringBuffer();
			for (Object o : pMaps.keySet()) {
				String lValue = UTMCStringUtils.convertObjectToString(pMaps.get(o));
				String lKey = UTMCStringUtils.convertObjectToString(o);
				if (null != lValue && null != lKey) {
					if(lIsFirst){
						lSB.append(lKey + "=" + lValue);
						lIsFirst = false;
					}else{
						lSB.append(",").append(lKey + "=" + lValue);
					}
				}
			}
			return lSB.toString();
		}
		return null;
	}
	
	public static String convertStringAToString(String ... aKvs) {
		if (null != aKvs && aKvs.length == 0) {
			return null;
		}
		StringBuffer lSB = new StringBuffer();
		boolean lFlag = false;
		if (aKvs != null && aKvs.length > 0) {
			for (int i = 0; i < aKvs.length; i++) {
				if (!UTMCStringUtils.isEmpty(aKvs[i])) {
					if (lFlag) {
						lSB.append(",");
					}
					lSB.append(aKvs[i]);
					lFlag = true;
				}
			}
		}
		return lSB.toString();
	}
	
	public static String convertMapToStringWithUrlEncoder(Map<String, String> pMaps) {
		if (null != pMaps) {
			boolean lIsFirst = true;
			StringBuffer lSB = new StringBuffer();
			for (Object o : pMaps.keySet()) {
				String lValue = UTMCStringUtils.convertObjectToString(pMaps.get(o));
				String lKey = UTMCStringUtils.convertObjectToString(o);
				if (null != lValue && null != lKey) {
					if(lIsFirst){
						try {
							lSB.append(URLEncoder.encode(lKey,"UTF-8") + "=" + URLEncoder.encode(lValue,"UTF-8"));
							lIsFirst = false;
						} catch (UnsupportedEncodingException e) {
							e.printStackTrace();
						}
					}else{
						try {
							lSB.append(",").append(URLEncoder.encode(lKey,"UTF-8") + "=" + URLEncoder.encode(lValue,"UTF-8"));
						} catch (UnsupportedEncodingException e) {
							e.printStackTrace();
						}
					}
				}
			}
			return lSB.toString();
		}
		return null;
	}
	
}